package com.perforb.jpaz.bootstrap;

import java.text.DecimalFormat;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.ParseException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.perforb.jpaz.UnknownPackageException;
import com.perforb.jpaz.extract.Extracter;

/**
 * A main entry point when starting from the
 * command line.
 * 
 * @author perforb
 */
public class Bootstrap
{
    private static final Log log = LogFactory.getLog(Bootstrap.class);

    public static void main(String[] args) throws Throwable
    {
        long start = System.currentTimeMillis();
        try {
            CommandLine line = CommandParser.getInstance().parse(args);
            Extracter extracter = new Extracter();
            extracter.execute(line);
        } catch (ParseException e) {
            System.out.println(e.getMessage());
            System.out.println();
            CommandParser.getInstance().usage();
        } catch (UnknownPackageException e) {
            System.out.println(e.getMessage());
            System.out.println();
            CommandParser.getInstance().usage();
        } catch (Throwable e) {
            log.fatal(e.getMessage(), e);
            throw e;
        } finally {
            log.info("elapsed time:" + measure(start));
        }
    }

    private static String measure(long start)
    {
        long end = System.currentTimeMillis();
        long elapse = end - start;
        String secs = new DecimalFormat("###,##0.00").format((double) elapse / 1000);
        return secs + "/sec";
    }
}
