package com.perforb.jpaz.extract.component;

import java.lang.reflect.Method;
import java.util.List;

/**
 * クラスファイルを表すクラスです. このクラスは Composite Pattern における
 * Leaf 役を担います.
 * 
 * @author perforb
 * @see Package
 * @see ClassFile
 */
public class ClassFile extends AbstractComponent
{
    /**
     * The package name that this class belong to.
     */
    private String   packageName;

    /**
     * defined methods in class.
     */
    private Method[] methods;

    /**
     * Constructor.
     */
    public ClassFile(String className, String packageName, Method[] methods)
    {
        super(className);
        this.packageName = packageName;
        this.methods = methods;
    }

    @Override
    public String getPackageName()
    {
        return packageName;
    }

    @Override
    public boolean addComponent(Component component)
    {
        return false;
    }

    @Override
    public boolean removeComponent(Component component)
    {
        return false;
    }

    @Override
    public List<Component> getChildren()
    {
        return null;
    }

    @Override
    public Method[] getMethods()
    {
        return methods;
    }

    @Override
    public boolean isPackage()
    {
        return false;
    }

    @Override
    public boolean isClassFile()
    {
        return true;
    }
}
