package com.perforb.jpaz.print;

import java.io.PrintWriter;

import com.perforb.jpaz.extract.CalculationResult;
import com.perforb.jpaz.extract.component.Component;

public abstract class AbstractPrinter implements Printer
{
    protected PrintWriter writer;

    public AbstractPrinter(PrintWriter writer)
    {
        this.writer = writer;
    }

    @Override
    public void setWriter(PrintWriter writer)
    {
        this.writer = writer;
    }

    @Override
    public void print(final Component component, final CalculationResult result)
    {
        if (component == null || component.isClassFile()) {
            throw new RuntimeException("");
        }
        for (Component c1 : component.getChildren()) {
            if (c1.isPackage()) {
                print(c1, result);
            } else if (c1.isClassFile()) {
                printMethodList(c1, result);
            }
        }
    }

    protected abstract void printMethodList(final Component component,
            final CalculationResult result);
}
