package com.perforb.jpaz.settings;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

public class PropertiesSettings implements Settings
{
    private static final Settings instance = new PropertiesSettings();
    private Map<String, String>   settings = new HashMap<String, String>();
    private boolean               initFlag = false;

    private PropertiesSettings()
    {
    }

    public static Settings getInstance()
    {
        return instance;
    }

    @Override
    public Map<String, String> load(String resource)
    {
        if (initFlag) return settings;
        Properties props = new Properties();
        try {
            props.load(Thread.currentThread().getContextClassLoader().getResourceAsStream(resource));
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        settings = new HashMap<String, String>();
        for (Map.Entry<Object, Object> entry : props.entrySet()) {
            settings.put((String) entry.getKey(), (String) entry.getValue());
        }
        initFlag = true;
        return settings;
    }
}
